/*
 * drvivethres.h
 *
 * home page of code is: http://smartmontools.sourceforge.net
 * address of support mailing list: smartmontools-support@lists.sourceforge.net
 *
 * copyright (c) 2003-11 philip williams, bruce allen
 * copyright (c) 2008-12 christian franke <smartmontools-support@lists.sourceforge.net>
 *
 * this program is free software; you can redistribute it and/or modify
 * it under the terms of the gnu general public license as published by
 * the free software foundation; either version 2, or (at your option)
 * any later version.
 *
 * you should have received a copy of the gnu general public license
 * (for example copying); if not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef DRIVETHRES_H_
#define DRIVETHRES_H_

#define DRIVETHRES_H_CVSID "$id: drivethres.h 3459 2014-07-26 21:10:37z chrfranke $\n"

#include "atacmds.h"

#define SMARTD_FIFO_PATH "/tmp/smartd_fifo"
#define VSMARTD_PID_FILE "/var/run/vsmartd.pid"
// Flags state
enum 
{
  THRES_INVALID = 0x00,   // User has configured Threshold
  THRES_RAW     = 0x01,   // Compare threshold against Raw value
  THRES_NORM    = 0x02,   // Compare threshold against Normal value
  THRES_LOW     = 0x04,   // Report Error if the value is less than the configured threshold
  THRES_HIGH    = 0x08,   // Report Error if the value is greater than the configured threshold
  THRES_VALID   = 0x80
};

// structure to store the threshold configuration for the attribute
struct attr_thres_cfg {
  unsigned char attr_id;
  unsigned int  attr_thres;
  unsigned char attr_flags;

  attr_thres_cfg()
     : attr_id(0) , attr_thres(0) , attr_flags(THRES_INVALID) { } 
};

/* The threshold configuration from smartd_thres.conf */
struct ata_smart_threshold_cfg{
  unsigned char flags;
  unsigned int threshold;
};

// Read drive(s) thershold values from configuration file.
int ReadDriveThresConfig();

// Check if the user defined threshold database exists
bool IsThresDbExists();

bool UpdateConfigThersholds(const char *drive_name,
			    const char * model, struct  ata_smart_values * smart_val,
			    struct ata_smart_threshold_cfg * attr_thres);

void check_attr_cfg_thres(const char *drive_name,
			  const ata_smart_attribute & attr, int attridx,
			  struct ata_smart_threshold_cfg * attr_thres,
			  const ata_vendor_attr_defs & defs);


void set_attr_status();
void send_attr_status();
int get_pid_from_pid_file(const char  * name);
int pkill(const char * name, int sig);

#endif
